
!TOException methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 03:57'!
exception: anException

	| context stackFrame next |
	self object: anException.
	context :=(GsProcess continuationFromLevel: 2) suspendedContext.
	frames := OrderedCollection new.
	topOfStack := stackFrame := (TOStackFrame new) context: context; exception: self; yourself.
	[ context isNil ] whileFalse: [
		frames add: stackFrame.
		context := context sender.
		context ifNotNil: [
			next :=  (TOStackFrame new) context: context; exception: self; yourself.
			stackFrame next: next.
			next previous: stackFrame.
			stackFrame := next ] ].! !

!TOException methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/20/2011 16:15'!
getArgMembers
	| members tempNames |
	members := OrderedCollection new.
	tempNames := self context tempNames.
	1 to: self context numArgs do: [ :index | 
		| each |
		each := tempNames at: index.
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: each;
					value: (self context tempNamed: each)) ].
	^ members
! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:22'!
home

	^self outerContext! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:27'!
numArgs

	^self selector numArgs! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:01'!
outerContext

	| hc |
	hc := self homeContext.
	hc == self ifTrue: [^nil ].
	^hc! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:24'!
sourceCode

	^self sourceString! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:29'!
tempNamed: aString

	| i |
	i := self tempNames indexOf: aString.
	^self tempAt: i! !

!TOContextInspector methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:29'!
getArgMembers
	| members tempNames |
	members := OrderedCollection new.
	tempNames := self context tempNames.
	1 to: self context numArgs do: [ :index | 
		| each |
		each := tempNames at: index.
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: each;
					value: (self context tempNamed: each)) ].
	^ members! !

!TOContextInspector methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:31'!
getContextMembers
	| members tempNames |
	members := OrderedCollection new.
	members
		add:
			((TOInspectorKeylessFieldSpec new)
				keyLabel: 'thisContext';
				value: self context).
	tempNames := self context tempNames.
	self context numArgs + 1 to: tempNames size do: [ :index | 
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: (tempNames at: index);
					value: (self context tempAt: index)) ].
	^ members! !
